const k = [
  "auto",
  "break",
  "case",
  "char",
  "const",
  "continue",
  "default",
  "do",
  "double",
  "else",
  "enum",
  "extern",
  "float",
  "for",
  "goto",
  "if",
  "int",
  "long",
  "register",
  "return",
  "short",
  "signed",
  "sizeof",
  "static",
  "struct",
  "switch",
  "typedef",
  "union",
  "unsigned",
  "void",
  "volatile",
  "while"
], w = ["NULL", "size_t", "true", "false", "bool", "FILE", "EOF"], q = {
  comment: "#5c6370",
  comment_start: "#5c6370",
  comment_end: "#5c6370",
  preprocessor: "#c678dd",
  defined: "#d19a66",
  header_file: "#98c379",
  keyword: "#c678dd",
  name: "#ef596f",
  string: "#98c379",
  "quote single": "#98c379",
  "quote double": "#98c379",
  format_specifier: "#d19a66",
  number: "#d19a66",
  bin_prefix: "#ef596f",
  hex_prefix: "#ef596f",
  oct_prefix: "#ef596f",
  function: "#61afef",
  operator: "#c678dd",
  escape: "#56b6c2",
  "open_paren bracket0": "#d19a66",
  "open_curly bracket0": "#d19a66",
  "close_paren bracket0": "#d19a66",
  "close_curly bracket0": "#d19a66",
  "open_paren bracket1": "#c678dd",
  "open_curly bracket1": "#c678dd",
  "close_paren bracket1": "#c678dd",
  "close_curly bracket1": "#c678dd",
  "open_paren bracket2": "#56b6c2",
  "close_curly bracket2": "#56b6c2",
  "close_paren bracket2": "#56b6c2",
  "open_curly bracket2": "#56b6c2",
  "open_square bracket0": "#c678dd",
  "close_square bracket0": "#c678dd",
  "open_square bracket1": "#d19a66",
  "close_square bracket1": "#d19a66",
  "open_square bracket2": "#56b6c2",
  "close_square bracket2": "#56b6c2"
}, d = /\s/, x = /^([0-9]+|\.)$/, m = /^[0-7]$/, L = /^[0-9a-f]$/i, E = /^[01]$/, I = /[a-z_]/i, S = /\d/;
function F(e) {
  let t = 0;
  const s = e.length, n = [];
  for (; t < s; ) {
    let l = e[t];
    if (d.test(l || "")) {
      let p = "";
      for (; d.test(l); )
        p += l, l = e[++t];
      n.push({ type: "whitespace", value: p });
      continue;
    }
    if (l === "/") {
      if (l = e[++t], l === "/") {
        ({ char: l, curr: t } = R(l, e, t, n));
        continue;
      }
      if (l === "*") {
        ({ char: l, curr: t } = O(l, e, t, n));
        continue;
      }
      n.push({ type: "operator", value: "/", subtype: "division" });
      continue;
    }
    if (l === '"') {
      ({ char: l, curr: t } = A(l, e, t, n, s));
      continue;
    }
    if (l === "'") {
      ({ char: l, curr: t } = N(n, l, e, t, s));
      continue;
    }
    if (l >= "0" && l <= "9") {
      ({ char: l, curr: t } = T(l, e, t, n));
      continue;
    }
    if (l === "#" && (t == 0 || e[t - 1] == `
`)) {
      ({ char: l, curr: t } = C(l, e, t, s, n));
      continue;
    }
    if (l === "#") {
      n.push({ type: "hash", value: "#" }), t++;
      continue;
    }
    if (I.test(l)) {
      ({ char: l, curr: t } = D(l, e, t, n));
      continue;
    }
    switch (l) {
      case "{":
        n.push({ type: "open_curly", value: "{" });
        break;
      case "}":
        n.push({ type: "close_curly", value: "}" });
        break;
      case "(":
        n.push({ type: "open_paren", value: "(" });
        break;
      case ")":
        n.push({ type: "close_paren", value: ")" });
        break;
      case "[":
        n.push({ type: "open_square", value: "[" });
        break;
      case "]":
        n.push({ type: "close_square", value: "]" });
        break;
      case "+":
        n.push({ type: "operator", value: "+", subtype: "addition" });
        break;
      case "-":
        n.push({ type: "operator", value: "-", subtype: "subtraction" });
        break;
      case "*":
        n.push({ type: "operator", value: "*", subtype: "multiplication" });
        break;
      case "/":
        n.push({ type: "operator", value: "/", subtype: "division" });
        break;
      case "%":
        n.push({ type: "operator", value: "%", subtype: "modulo" });
        break;
      case "=":
        n.push({ type: "operator", value: "=", subtype: "assignment" });
        break;
      case "&":
        n.push({ type: "operator", value: "&", subtype: "address" });
        break;
      case "|":
        n.push({ type: "operator", value: "|", subtype: "or" });
        break;
      case "^":
        n.push({ type: "operator", value: "^", subtype: "xor" });
        break;
      case "~":
        n.push({ type: "operator", value: "~", subtype: "not" });
        break;
      case "!":
        n.push({ type: "operator", value: "!", subtype: "negate" });
        break;
      case "<":
        n.push({ type: "operator", value: "<", subtype: "less_than" });
        break;
      case ">":
        n.push({ type: "operator", value: ">", subtype: "greater_than" });
        break;
      case "?":
        n.push({ type: "operator", value: "?", subtype: "question" });
        break;
      case ":":
        n.push({ type: "colon", value: ":" });
        break;
      case ".":
        n.push({ type: "operator", value: ".", subtype: "dot" });
        break;
      case ",":
        n.push({ type: "comma", value: "," });
        break;
      case ";":
        n.push({ type: "semicolon", value: ";" });
        break;
      default:
        console.warn("unrecognized character: " + l), n.push({ type: "unknown", value: l });
    }
    t++;
  }
  return n;
}
function C(e, t, s, n, l) {
  let p = e;
  for (e = t[++s]; e !== " " && !(s >= n); )
    p += e, e = t[++s];
  return l.push({ type: "preprocessor", value: p }), p === "#include" && ({ char: e, curr: s } = z(e, t, s, l)), { char: e, curr: s };
}
function z(e, t, s, n) {
  let l = "";
  for (; e !== '"' && e !== "<"; )
    l += e, e = t[++s];
  n.push({ type: "whitespace", value: l }), l = "";
  let p = "";
  if (e === '"') {
    for (p = e, e = t[++s]; e !== '"'; ) {
      if (s >= t.length) {
        console.warn("header file unclosed at end of file");
        break;
      }
      if (s >= t.length)
        break;
      l += e, p += e, e = t[++s];
    }
    return p += e, s++, n.push({ type: "header_file", value: p }), { char: e, curr: s };
  }
  if (e === "<") {
    for (p = e, e = t[++s]; e !== ">"; ) {
      if (s >= t.length) {
        console.warn("header file unclosed at end of file");
        break;
      }
      if (s >= t.length)
        break;
      l += e, p += e, e = t[++s];
    }
    return p += e, s++, n.push({ type: "header_file", value: p }), { char: e, curr: s };
  }
  return { char: e, curr: s };
}
function D(e, t, s, n) {
  let l = "";
  for (; /[a-zA-Z0-9_]/.test(e || ""); )
    l += e, e = t[++s];
  if (k.includes(l))
    n.push({ type: "keyword", value: l });
  else {
    if (e === "(")
      return n.push({ type: "function", value: l }), { char: e, curr: s };
    w.includes(l) ? n.push({ type: "defined", value: l }) : n.push({ type: "name", value: l });
  }
  return { char: e, curr: s };
}
function T(e, t, s, n) {
  let l = e;
  if (e = t[++s], l === "0") {
    if (e === "x" || e === "X")
      return { char: e, curr: s } = H(l, e, t, s, n), { char: e, curr: s };
    if (e === "b" || e === "B")
      return { char: e, curr: s } = G(l, e, t, s, n), { char: e, curr: s };
    if (e === ".")
      return { char: e, curr: s } = y(l, e, t, s, n), { char: e, curr: s };
    if (m.test(e))
      return { char: e, curr: s } = $(l, e, t, s, n), { char: e, curr: s };
    ({ char: e, curr: s } = y(l, e, t, s, n));
  } else
    ({ char: e, curr: s } = y(l, e, t, s, n));
  return { char: e, curr: s };
}
function $(e, t, s, n, l) {
  let p = "";
  for (l.push({ type: "oct_prefix", value: e }); m.test(t); )
    p += t, t = s[++n];
  return l.push({ type: "number", value: p, subtype: "octal" }), { char: t, curr: n };
}
function G(e, t, s, n, l) {
  let p = "";
  for (l.push({ type: "bin_prefix", value: e + t }), t = s[++n]; E.test(t); )
    p += t, t = s[++n];
  return l.push({ type: "number", value: p, subtype: "binary" }), { char: t, curr: n };
}
function H(e, t, s, n, l) {
  let p = "";
  for (l.push({ type: "hex_prefix", value: e + t }), t = s[++n]; L.test(t); )
    p += t, t = s[++n];
  return l.push({ type: "number", value: p, subtype: "hexadecimal" }), { char: t, curr: n };
}
function y(e, t, s, n, l) {
  let p = e, a = 0;
  for (; S.test(t) || t === "." && ++a; )
    p += t, t = s[++n];
  return a > 1 && (console.warn("invalid number: " + p), l.push({ type: "unknown", value: p, subtype: "invalid" }), p = ""), l.push({ type: "number", value: p }), { char: t, curr: n };
}
function N(e, t, s, n, l) {
  let p = "";
  for (e.push({ type: "quote", value: "'", subtype: "single" }), t = s[++n]; t !== "'"; ) {
    if (n >= l) {
      console.warn("character literal unclosed at end of file");
      break;
    }
    if (t == "\\") {
      e.push({ type: "string", value: p, subtype: "single" }), { value: p, char: t, curr: n } = r(e, p, t, s, n);
      continue;
    }
    p += t, t = s[++n];
  }
  return e.push({ type: "string", value: p, subtype: "single" }), t !== "'" ? console.warn("character literal unclosed at end of file") : e.push({ type: "quote", value: "'", subtype: "single" }), n++, { char: t, curr: n };
}
function A(e, t, s, n, l) {
  let p = "";
  for (e = t[++s], n.push({ type: "quote", value: '"', subtype: "double" }); e !== '"'; ) {
    if (s >= l) {
      console.warn("string unclosed at end of file");
      break;
    }
    if (e == "\\") {
      n.push({ type: "string", value: p, subtype: "double" }), { value: p, char: e, curr: s } = r(n, p, e, t, s);
      continue;
    }
    if (e == "%") {
      n.push({ type: "string", value: p, subtype: "double" }), p = "", n.push({ type: "format_specifier", value: "%" });
      let i = "";
      e = t[++s];
      let v = 0;
      for (; x.test(e); )
        e == "." && v++, i += e, e = t[++s];
      if (v > 1) {
        p += i, n.push({ type: "string", value: p, subtype: "double" });
        continue;
      }
      i.length >= 1 && (n.push({ type: "format_specifier", value: i }), i = "");
      const _ = e, u = t[s + 1], b = t[s + 2];
      switch (_) {
        case "l":
          switch (u) {
            case "l":
              o(b), a(i);
              break;
            default:
              o(u, !1) && f(i);
              break;
          }
          break;
        case "L":
          o(u, !1) && f(i);
          break;
        case "h":
          switch (u) {
            case "h":
              o(b, !1) && a(i);
              break;
            default:
              o(u, !1) && f(i);
              break;
          }
          break;
        case "j":
          switch (u) {
            case "j":
              o(b) && a(i);
              break;
            default:
              o(u, !1) && f(i);
              break;
          }
          break;
        case "z":
          switch (u) {
            case "z":
              o(b) && a(i);
              break;
            default:
              o(u, !1) && f(i);
              break;
          }
          break;
        case "t":
          switch (u) {
            case "t":
              o(b) && a(i);
              break;
            default:
              o(u, !1) && f(i);
              break;
          }
          break;
        default:
          X(_) && g(i);
          break;
      }
      n.push({ type: "string", value: i }), p = "";
      continue;
    }
    p += e, e = t[++s];
  }
  return n.push({ type: "string", value: p, subtype: "double" }), e !== '"' ? console.warn("string unclosed at end of file") : n.push({ type: "quote", value: '"', subtype: "double" }), s++, { char: e, curr: s };
  function a(i) {
    i += e + t[s + 1] + t[s + 2], s += 3, e = t[s], n.push({ type: "format_specifier", value: i });
  }
  function f(i) {
    i += e + t[s + 1], s += 2, e = t[s], n.push({ type: "format_specifier", value: i });
  }
  function g(i) {
    i += e, s++, e = t[s], n.push({ type: "format_specifier", value: i });
  }
}
function O(e, t, s, n) {
  let l = "";
  for (n.push({ type: "comment_start", value: "/*", subtype: "multi" }), s += 1; s < t.length && !M(t, s); )
    l += t[s], s++;
  return n.push({ type: "comment", value: l, subtype: "multi" }), s < t.length ? (n.push({ type: "comment_end", value: "*/", subtype: "multi" }), s += 2) : console.warn("multi-line comment unclosed at end of file"), { char: e, curr: s };
}
function M(e, t) {
  return e[t] === "*" && e[t + 1] === "/";
}
function R(e, t, s, n) {
  let l = "";
  for (n.push({ type: "comment_start", value: "//", subtype: "single" }), s += 1; s < t.length && t[s] !== `
`; )
    l += t[s], s++;
  return n.push({ type: "comment", value: l, subtype: "single" }), { char: e, curr: s };
}
function r(e, t, s, n, l) {
  t = "";
  let p = s;
  const a = n[l + 1];
  return W(a) ? (p += a, l++) : console.warn("unknown escape sequence:", p + a), e.push({ type: "escape", value: p }), l++, s = n[l], { value: t, char: s, curr: l };
}
function W(e) {
  return e === "n" || e === "t" || e === "r" || e === "v" || e === "b" || e === "a" || e === "f" || e === "?" || e === "'" || e === '"' || e === "0" || e === "\\";
}
function o(e, t = !0) {
  return e = t ? e : e.toLowerCase(), e === "a" || e === "c" || e === "d" || e === "e" || e === "f" || e === "g" || e === "i" || e === "n" || e === "o" || e === "p" || e === "s" || e === "u" || e === "x";
}
function X(e) {
  return e === "d" || e === "i" || e === "u" || e === "o" || e === "x" || e === "X" || e === "f" || e === "F" || e === "e" || e === "E" || e === "g" || e === "G" || e === "c" || e === "s" || e === "p" || e === "n" || e === "%";
}
function j(e) {
  const t = [];
  let s = 0, n = 0, l = 0;
  return e.forEach((p) => {
    switch (p.type) {
      case "open_paren":
        l >= 0 && (p.type += " bracket" + l % 3), l++;
        break;
      case "close_paren":
        l--, l >= 0 && (p.type += " bracket" + l % 3);
        break;
      case "open_curly":
        n >= 0 && (p.type += " bracket" + n % 3), n++;
        break;
      case "close_curly":
        n--, n >= 0 && (p.type += " bracket" + n % 3);
        break;
      case "open_square":
        s >= 0 && (p.type += " bracket" + s % 3), s++;
        break;
      case "close_square":
        s--, s >= 0 && (p.type += " bracket" + s % 3);
        break;
      case "quote":
        p.type += " " + p.subtype;
        break;
    }
    t.push(p);
  }), t;
}
function B(e) {
  let t = "";
  for (const s of e)
    s.type === "header_file" && (s.value = s.value.replace(">", "&gt").replace("<", "&lt")), t += `<span class="aurora-${s.type}">${s.value}</span>`;
  return t;
}
function P(e, t) {
  let s = "";
  for (const n of e)
    n.type === "header_file" && (n.value = n.value.replace(">", "&gt").replace("<", "&lt")), t[n.type] ? s += `<span style="color:${t[n.type]}">${n.value}</span>` : s += n.value;
  return s;
}
const K = {
  mode: "class"
};
function U(e, t = K) {
  const s = F(e), n = j(s);
  let l = "";
  return t.mode === "class" ? l = B(n) : l = P(n, t.styles || q), l;
}
export {
  B as classHighlighter,
  U as default,
  P as inlineHighlighter,
  j as nodeGenerator,
  q as one_dark_pro,
  F as tokenizer
};
