/**
 * Tokenizer for C language
 * by Abinash Karmakar
 * 2023-10-22
 */
export type Token = {
    type: 'comment_start' | 'comment_end' | 'comment' | 'preprocessor' | 'defined' | 'header_file' | 'keyword' | 'name' | 'string' | 'quote' | 'format_specifier' | 'number' | 'bin_prefix' | 'oct_prefix' | 'hex_prefix' | 'bin_literal' | 'oct_literal' | 'hex_literal' | 'function' | 'operator' | 'escape' | 'comma' | 'semicolon' | 'colon' | 'hash' | 'open_paren' | 'close_paren' | 'open_curly' | 'close_curly' | 'open_square' | 'close_square' | 'whitespace' | 'unknown';
    value: string;
    subtype?: string;
};
export default function tokenizer(code: string): Token[];
